/**
 * Copyright 2022 IBM Corp. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import { SdkConfigResponse } from './models/SdkConfigResponse';
import Feature from './models/Feature';
import Property from './models/Property';
export default class ConfigurationHandler {
    private static instance;
    private constructor();
    private region;
    private guid;
    private apikey;
    private overrideServiceUrl;
    init(region: string, guid: string, apikey: string, overrideServiceUrl: string): void;
    setContext(collectionId: string, environmentId: string): Promise<void>;
    saveInCache(data: SdkConfigResponse): void;
    connectEventSource(): Promise<void>;
    getFeature(featureId: string): Feature;
    getFeatures(): {
        [x: string]: Feature;
    };
    getProperty(propertyId: string): Property;
    getProperties(): {
        [x: string]: Property;
    };
    static getInstance(): ConfigurationHandler;
}
