"use strict";
/**
 * Copyright 2022 IBM Corp. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
Object.defineProperty(exports, "__esModule", { value: true });
var FeatureSegmentRule = /** @class */ (function () {
    function FeatureSegmentRule(_a) {
        var rules = _a.rules, value = _a.value, order = _a.order, _b = _a.rollout_percentage, rollout_percentage = _b === void 0 ? 100 : _b;
        this.rules = rules;
        this.value = value;
        this.order = order;
        this.rollout_percentage = rollout_percentage;
    }
    FeatureSegmentRule.prototype.getRules = function () {
        return this.rules;
    };
    FeatureSegmentRule.prototype.getValue = function () {
        return this.value;
    };
    FeatureSegmentRule.prototype.getOrder = function () {
        return this.order;
    };
    FeatureSegmentRule.prototype.getRolloutPercentage = function () {
        return this.rollout_percentage;
    };
    return FeatureSegmentRule;
}());
exports.default = FeatureSegmentRule;
