"use strict";
/**
 * Copyright 2022 IBM Corp. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getNormalizedValue = void 0;
var murmurhash_1 = __importDefault(require("murmurhash"));
var constants_1 = require("./constants");
function computeHash(str) {
    var SEED = 0;
    return murmurhash_1.default.v3(str, SEED);
}
function getNormalizedValue(str) {
    return Math.floor((computeHash(str) / constants_1.MAX_HASH_VALUE) * constants_1.NORMALIZER);
}
exports.getNormalizedValue = getNormalizedValue;
