"use strict";
/**
 * Copyright 2022 IBM Corp. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var apimanager_1 = require("./apimanager");
var Constants = __importStar(require("./constants"));
var custom_error_1 = require("./custom-error");
var Metering = /** @class */ (function () {
    function Metering() {
        this.meteringInterval = 300 * 1000; // 5 minutes
        this.startMetering = false; // flag to start sendMetering() only after addMetering() is called. (i.e., when the first evaluation is added)
        this.meteringFeatureData = {};
        this.meteringPropertyData = {};
    }
    Metering.prototype.stopTimer = function () {
        if (this.timer) {
            clearInterval(this.timer);
            delete this.timer;
        }
    };
    Metering.prototype.init = function (collectionId, environmentId) {
        this.collectionId = collectionId;
        this.environmentId = environmentId;
    };
    Metering.prototype.addMetering = function (entityId, segmentId, featureId, propertyId) {
        var _this = this;
        if (!this.startMetering) {
            this.timer = setInterval(function () {
                _this.sendMetering(false);
            }, this.meteringInterval);
            this.startMetering = true;
        }
        var meteringData = featureId !== null ? this.meteringFeatureData : this.meteringPropertyData;
        var modifyKey = (featureId !== null ? featureId : propertyId);
        var time = "".concat((new Date()).toISOString().split('.')[0], "Z");
        var metric = {
            count: 1,
            evaluation_time: time,
        };
        if (Object.prototype.hasOwnProperty.call(meteringData, modifyKey)) {
            if (Object.prototype.hasOwnProperty.call(meteringData[modifyKey], entityId)) {
                if (Object.prototype.hasOwnProperty.call(meteringData[modifyKey][entityId], segmentId)) {
                    meteringData[modifyKey][entityId][segmentId].evaluation_time = time;
                    meteringData[modifyKey][entityId][segmentId].count += 1;
                }
            }
            else {
                meteringData[modifyKey][entityId] = {};
                meteringData[modifyKey][entityId][segmentId] = metric;
            }
        }
        else {
            meteringData[modifyKey] = {};
            meteringData[modifyKey][entityId] = {};
            meteringData[modifyKey][entityId][segmentId] = metric;
        }
    };
    Metering.prototype.buildRequestBody = function (sendMeteringData, result, key) {
        var _this = this;
        var body = {};
        var usages = [];
        var data = sendMeteringData;
        Object.keys(data).forEach(function (featureId) {
            Object.keys(data[featureId]).forEach(function (entityId) {
                Object.keys(data[featureId][entityId]).forEach(function (segmentId) {
                    var _a;
                    var usage = (_a = {},
                        _a[key] = featureId,
                        _a['entity_id'] = entityId === Constants.DEFAULT_ENTITY_ID ? null : entityId,
                        _a['segment_id'] = segmentId === Constants.DEFAULT_SEGMENT_ID ? null : segmentId,
                        _a['evaluation_time'] = data[featureId][entityId][segmentId].evaluation_time,
                        _a['count'] = data[featureId][entityId][segmentId].count,
                        _a);
                    usages.push(usage);
                    body.collection_id = _this.collectionId;
                    body.environment_id = _this.environmentId;
                    body.usages = usages;
                });
            });
        });
        result.push(body);
    };
    Metering.prototype.sendToServer = function (data, keepalive) {
        return __awaiter(this, void 0, void 0, function () {
            var e_1;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, (0, apimanager_1.retryablePostMetering)(data, keepalive)];
                    case 1:
                        _a.sent();
                        return [3 /*break*/, 3];
                    case 2:
                        e_1 = _a.sent();
                        if (e_1 instanceof custom_error_1.APIError) {
                            if ((e_1.statusCode >= 500 && e_1.statusCode <= 599) || e_1.statusCode === 429) {
                                setTimeout(function () {
                                    _this.sendToServer(data, keepalive);
                                }, this.meteringInterval);
                            }
                            else {
                                console.error('Unexpected error: ', e_1);
                            }
                        }
                        else {
                            console.error('Unexpected error: ', e_1);
                        }
                        return [3 /*break*/, 3];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    Metering.prototype.sendSplitMetering = function (data, count, keepalive) {
        var lim = 0;
        var subUsagesArray = data.usages;
        while (lim < count) {
            var endIndex = lim + Constants.DEFAULT_USAGE_LIMIT >= count ? count : lim + Constants.DEFAULT_USAGE_LIMIT;
            var body = {};
            var usages = [];
            for (var i = lim; i < endIndex; i += 1) {
                usages.push(subUsagesArray[i]);
            }
            body.collection_id = data.collection_id;
            body.environment_id = data.environment_id;
            body.usages = usages;
            this.sendToServer(body, keepalive);
            lim += Constants.DEFAULT_USAGE_LIMIT;
        }
    };
    Metering.prototype.sendMetering = function (keepalive) {
        return __awaiter(this, void 0, void 0, function () {
            var sendFeatureData, sendPropertyData, result;
            var _this = this;
            return __generator(this, function (_a) {
                try {
                    sendFeatureData = this.meteringFeatureData;
                    sendPropertyData = this.meteringPropertyData;
                    this.meteringFeatureData = {};
                    this.meteringPropertyData = {};
                    if ((Object.keys(sendFeatureData).length) <= 0 && (Object.keys(sendPropertyData).length <= 0)) {
                        return [2 /*return*/];
                    }
                    result = [];
                    if (Object.keys(sendFeatureData).length > 0) {
                        this.buildRequestBody(sendFeatureData, result, 'feature_id');
                    }
                    if (Object.keys(sendPropertyData).length > 0) {
                        this.buildRequestBody(sendPropertyData, result, 'property_id');
                    }
                    result.forEach(function (data) {
                        var count = data.usages.length;
                        if (count > Constants.DEFAULT_USAGE_LIMIT) {
                            _this.sendSplitMetering(data, count, keepalive);
                        }
                        else {
                            _this.sendToServer(data, keepalive);
                        }
                    });
                }
                catch (e) {
                    console.error(e);
                }
                return [2 /*return*/];
            });
        });
    };
    Metering.getInstance = function () {
        if (!Metering.instance) {
            Metering.instance = new Metering();
        }
        return Metering.instance;
    };
    return Metering;
}());
exports.default = Metering;
