/**
 * Copyright 2022 IBM Corp. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import { EventSourcePolyfillInit } from '../polyfill/eventsource';
interface UrlBuilderOptions {
    region: string;
    guid: string;
    apikey: string;
    collectionId: string;
    environmentId: string;
    overrideServiceUrl: string;
}
export default class UrlBuilder {
    private static instance;
    private region;
    private guid;
    private apikey;
    private collectionId;
    private environmentId;
    private overrideServiceUrl;
    private constructor();
    init(options: UrlBuilderOptions): void;
    getAPICallHeaders(isPost?: boolean): Headers;
    getEventSourceHeaders(): EventSourcePolyfillInit;
    getBaseServiceUrl(): string;
    getMeteringUrl(): string;
    getEventSourceUrl(): string;
    static getInstance(): UrlBuilder;
}
export {};
