"use strict";
/**
 * Copyright 2022 IBM Corp. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var package_json_1 = require("../../package.json");
var Constants = __importStar(require("./constants"));
var UrlBuilder = /** @class */ (function () {
    function UrlBuilder() {
    }
    UrlBuilder.prototype.init = function (options) {
        this.region = options.region;
        this.guid = options.guid;
        this.apikey = options.apikey;
        this.collectionId = options.collectionId;
        this.environmentId = options.environmentId;
        this.overrideServiceUrl = options.overrideServiceUrl;
    };
    UrlBuilder.prototype.getAPICallHeaders = function (isPost) {
        if (isPost === void 0) { isPost = false; }
        var headers = new Headers();
        headers.append('Authorization', this.apikey);
        headers.append('User-Agent', ''.concat('appconfiguration-js-client-sdk/v', package_json_1.version, ' (', navigator.userAgent, ')'));
        if (isPost) {
            headers.append('Content-Type', 'application/json');
        }
        return headers;
    };
    UrlBuilder.prototype.getEventSourceHeaders = function () {
        return {
            headers: {
                'Authorization': this.apikey,
                'User-Agent': ''.concat('appconfiguration-js-client-sdk/v', package_json_1.version, ' (', navigator.userAgent, ')')
            },
            heartbeatTimeout: Constants.EVENT_SOURCE_HEARTBEAT_TIMEOUT
        };
    };
    UrlBuilder.prototype.getBaseServiceUrl = function () {
        if (this.overrideServiceUrl) {
            return this.overrideServiceUrl;
        }
        return ''.concat('https://', this.region, '.apprapp.cloud.ibm.com');
    };
    UrlBuilder.prototype.getMeteringUrl = function () {
        return ''.concat(this.getBaseServiceUrl(), '/apprapp/events/v1/instances/', this.guid, '/usage');
    };
    UrlBuilder.prototype.getEventSourceUrl = function () {
        return ''.concat(this.getBaseServiceUrl(), '/apprapp/feature/v1/instances/', this.guid, '/environments/', this.environmentId, '/sse/subscribe?collection_id=', this.collectionId);
    };
    UrlBuilder.getInstance = function () {
        if (!UrlBuilder.instance) {
            UrlBuilder.instance = new UrlBuilder();
        }
        return UrlBuilder.instance;
    };
    return UrlBuilder;
}());
exports.default = UrlBuilder;
